/*
 * YOU SHOULD CAREFULLY READ THE FOLLOWING TERMS AND CONDITIONS BEFORE 
 * INSTALLING AND USING THIS PRODUCT, 
 * THE USE OF WHICH IS LICENSED BY 3COM CORPORATION ("3COM")
 * and others as set forth below for your USE ONLY AS SET FORTH BELOW. 
 * DOWNLOADING, INSTALLING OR OTHERWISE USING ANY PART OF THE SOFTWARE OR 
 * DOCUMENTATION INDICATES THAT YOU ACCEPT THESE TERMS AND CONDITIONS.  
 * IF YOU DO NOT AGREE TO THE TERMS AND CONDITIONS OF THIS AGREEMENT, 
 * DO NOT DOWNLOAD, INSTALL OR OTHERWISE USE THE SOFTWARE OR DOCUMENTATION. 
 * AND IF YOU HAVE RECEIVED THE SOFTWARE AND DOCUMENTATION ON PHYSICAL MEDIA, 
 * RETURN THE ENTIRE PRODUCT WITH THE SOFTWARE AND DOCUMENTATION UNUSED TO THE
 * SUPPLIER WHERE YOU OBTAINED IT.

 * This driver (3c990.c) has been written to work with the 3cr990 product line
 * of network cards, manufactured by 3Com Corp.
 * This driver is not intended for any other product line, including the 3c59x
 * or 3C90x product lines (although drivers with both of these names,
 * and for both of these product lines, are available ).
 *
 * It does not work with the 2.3 kernel; only the 2.0 and 2.2 at this point.
 * The driver contains no support now for architectures other than IA-32 bit.
 *
 * To force the media selection, use the command line argument force=X,
 * where X denotes the selection as follows:
 * 0=10(megabit)Half(Duplex); 1=10Full; 2=100Half; 3=100Full; 4=auto (default)
 * e.g. insmod 3c990.o force=1
 * ... should give you 10 megabit full duplex forced action.
 * NOTE: Fiber cards are only capable of 100Half and 100Full(default)
 *
 * You may contact 3Com for updates and information (regarding this driver) at:
 * http://support.3com.com/infodeli/tools/nic/3c990.htm
 *
 * You may request or submit driver modifications at:
 * http://support.3com.com/infodeli/tools/nic/linuxrequest.htm
 *
 * If you would like more information about compiling the driver than is 
 * available at the bottom of this file, you may choose to reference:
 * http://cesdis.gsfc.nasa.gov/linux/misc/modules.html
 * and/or you may reference the readme file for the 3c90x driver.
 *
 * License to "tc990image"
 * The binary image "tc990image" is licensed to users by 3Com Corporation, 
 * with intended use for 3Com's Network Interface Card models 3CR990-x.
 * (Where x indicates any extension model number.)
 * LICENSE:  3Com grants you a nonexclusive, nontransferable 
 * (except as specified herein) license to use the tc990image in conjunction 
 * with your use of 3Com's Network Interface Card models 3CR990-x as specified 
 * above. You are not permitted to lease, rent, distribute or sublicense 
 * (except as specified herein) the tc990image or to use the tc990image or in 
 * any other unauthorized manner.  Further, no license is granted to you in the
 * human readable code of the Software (source code).  Except as provided 
 * below, this Agreement does not grant you any rights to patents, copyrights, 
 * trade secrets, trademarks, or any other rights with respect to the Software 
 * or Documentation.
 * Subject to the restrictions set forth herein, the tc990image is licensed to 
 * be used on any workstation or any network server owned by or leased to you, 
 * for your internal use, provided that the tc990image is used only in 
 * connection with this 3Com product.  You may reproduce and provide one (1) 
 * copy of the tc990image for each such workstation or network server on which 
 * the Software is used as permitted hereunder.  Otherwise, the Software and 
 * Documentation may be copied only as essential for backup or archive purposes
 * in support of your use of the Software as permitted hereunder.  Each copy 
 * of the tc990image must contain 3Com's and its licensors' proprietary rights 
 * and copyright notices in the same form as on the original.  You agree not to
 * remove or deface any portion of any legend provided on any licensed program 
 * or documentation delivered to you under this Agreement.
 * ASSIGNMENT;   You may transfer the tc990image and the licenses granted 
 * herein to another party in the same country in which you obtained it if the 
 * other party agrees in writing to accept and be bound by the terms and 
 * conditions of this Agreement. If you transfer the tc990image, you must at 
 * the same time either transfer all copies of the Software and Documentation 
 * to the party or you must destroy any copies not transferred. Except as set 
 * forth above, you may not assign or transfer your rights.
 *
 * NO REVERSE ENGINEERING:  Modification, reverse engineering, reverse 
 * compiling, or disassembly of the tc990image is expressly prohibited. 
 * However, if you are a European Union ("EU") resident, information necessary 
 * to achieve interoperability of the tc990image with other programs within the
 * meaning of the EU Directive on the Legal Protection of Computer Programs is 
 * available to you from 3Com upon written request.
 * TRADE SECRETS; TITLE:  You acknowledge and agree that the structure, 
 * sequence and organization of the tc990image are the valuable trade secrets 
 * of 3Com and its suppliers. You agree to hold such trade secrets in 
 * confidence. You further acknowledge and agree that ownership of, and title 
 * to, the tc990image and all subsequent copies thereof regardless of the form 
 * or media are held by 3Com.
 *
 * License to this driver
 * Some material in this driver has been adopted from pci-skeleton.c, 
 * a Linux PCI network adapter skeleton device driver. 
 * pci-skeleton.c written in 1998-1999 by Donald Becker.
 * The author of pci-skeleton.c may be reached as becker@scyld.com.
 * More information about Becker is available at http://www.scyld.com/
 *
 * Except as otherwise provided, This software and pci-skeleton.c, may be used 
 * and distributed according to the terms of the GNU Public License (GPL), 
 * incorporated herein by reference.
 *
 * UNITED STATES GOVERNMENT LEGENDS:  The portions of this Driver developed by 
 * 3Com, and the tc990image ("Software") is commercial in nature and developed 
 * solely at private expense.  The Software is delivered as 
 * "Commercial Computer Software" as defined in DFARS 252.227-7014 (June 1995) 
 * or as a commercial item as defined in FAR 2.101(a) and as such is provided 
 * with only such rights as are provided herein.  Technical data is provided 
 * with limited rights only as provided in DFAR 252.227-7015 (Nov. 1995) or 
 * FAR 52.227-14 (June 1987), whichever is applicable.
 *
 * TERM AND TERMINATION:  The licenses to the Software granted hereunder are 
 * perpetual unless terminated earlier as specified below or otherwise 
 * provided. You may terminate the licenses and this Agreement at any time by 
 * destroying the Software and Documentation together with all copies and 
 * merged portions in any form. The licenses and this Agreement will also 
 * terminate immediately if you fail to comply with any term or condition of 
 * this Agreement. Upon such termination you agree to destroy the Software and 
 * Documentation, together with all copies and merged portions in any form.
 *
 * LIMITED WARRANTIES AND LIMITATION OF LIABILITY: This driver and  tc990image 
 * are provided with no warranty, including warranty of fitness for any 
 * particular purpose.  3Com assumes no liability for any damages or injuries
 * resulting from use of the driver or tc990image file.
 * GOVERNING LAW:   This License shall be governed by the laws of the State of 
 * California, U.S.A. excluding its conflicts of laws principles and excluding 
 * the United Nations Convention on Contracts for the 
 * International Sale of Goods.
 * SEVERABILITY:  In the event any provision of this License is found to be 
 * invalid, illegal or unenforceable, the validity, legality and enforceability
 * of any of the remaining provisions shall not in any way be affected or 
 * impaired and a valid, legal and enforceable provision of similar intent and 
 * economic impact shall be substituted therefor.
 * ENTIRE AGREEMENT:  This Agreement sets forth the entire understanding and 
 * agreement between you and 3Com and supersedes all prior agreements, whether 
 * written or oral, with respect to the Software and Documentation, and may be 
 * amended only in a writing signed by both parties.
 * Should you have any questions concerning this Agreement or if you desire to 
 * contact 3Com for any reason, please contact the 3Com subsidiary serving your
 * country, or write: 
 * 3Com Corporation, Customer Support Information, 
 * 5400 Bayfront Plaza, Santa Clara, CA  95052
 */

#include "3c990.h"

#ifdef DEBUG
MODULE_PARM(debug, "i");
#endif //DEBUG
#ifdef DEBUG
static u32 debug = DEBUG_ERROR | DEBUG_INITIALIZE | DEBUG_FUNCTION | DEBUG_IOCTL | DEBUG_CMD_RSP_RING | DEBUG_SEND | DEBUG_RECEIVE | DEBUG_INTERRUPT ;
#endif

/* A list of our installed devices, for removing the driver module. */
static struct net_device *root_net_dev = NULL;
/*----------------------------------------------------------------------
 * pci_etherdev_probe --
 *  This routine is called at the time of insmod to find all of the 3c990
 *	in the system and initializes them to wait for the open call
 *
 * Arguments:
 *  dev     - a holder for a device pointer (passed in as NULL)
 *	pci_tbl - an array that holds the Device ID supported by this driver
 *
 * Results:
 *  -ENODEV  if no cards are found
 *	0			   If successful
 *----------------------------------------------------------------------
 */
static u16 pci_etherdev_probe( struct net_device *dev, struct pci_id_info pci_tbl[] )
{
    u16 pci_command;
    u16 chip_idx, irq = 0;
    struct pci_dev *pdev = 0;
    u16 cards_found = 0;
    unsigned char cacheSz;
    u8 pci_latency;
    u16 vendor, device, subsystem;
    long ioaddr ;
    u8 rev;

#if LINUX_VERSION_CODE < 0x20343
    static u16 pci_index = 0;
    unsigned char pci_bus, pci_device_fn;
#endif
	DBGPRINT_INITIALIZE(("pci_etherdev_probe IN:\n"));

#if LINUX_VERSION_CODE < 0x20343
    for (;pci_index < 0xff; pci_index++) {
        if (pcibios_find_class(PCI_CLASS_NETWORK_ETHERNET << 8, pci_index,
                               &pci_bus, &pci_device_fn) != PCIBIOS_SUCCESSFUL)
            break;

        pcibios_read_config_word(pci_bus, pci_device_fn, PCI_VENDOR_ID, &vendor);
        pcibios_read_config_word(pci_bus, pci_device_fn, PCI_DEVICE_ID, &device);
        pcibios_read_config_word(pci_bus, pci_device_fn, PCI_SUBSYSTEM_ID, &subsystem);
#else

        while ((pdev = pci_find_class(PCI_CLASS_NETWORK_ETHERNET<<8, pdev))) {

        vendor = pdev->vendor;
        device = pdev->device;
        pci_read_config_word(pdev, PCI_SUBSYSTEM_ID, &subsystem);
#endif
        if (vendor != tc990_VENDOR_ID) continue;

        for (chip_idx = 0; pci_tbl[chip_idx].device_id; chip_idx++){
            if (device == pci_tbl[chip_idx].device_id){
				if(subsystem & SUBSYSTEM_SECURED_FIRMWARE){
					printk(KERN_INFO "Warning Unsupported Firmware Image: found a NIC with a secured firmware image\n");
				}
				if (subsystem == pci_tbl[chip_idx].subsystem_id) break;
			}
		}    
        if (pci_tbl[chip_idx].device_id == 0) continue;

#if LINUX_VERSION_CODE < 0x20343
        pcibios_read_config_byte(pci_bus, pci_device_fn,
                                 PCI_CLASS_REVISION, &rev); 
#else
        pci_read_config_byte(pdev, PCI_CLASS_REVISION, &rev);
#endif

        {   
#if LINUX_VERSION_CODE < 0x20343
            pdev = pci_find_slot( pci_bus, pci_device_fn);
            ioaddr = pdev->base_address[TC990_BASE_ADDRESS_REG];
            irq = pdev->irq;

#else
            ioaddr = pdev->resource[TC990_BASE_ADDRESS_REG].start;
            irq = pdev->irq;

#endif
        }


#if LINUX_VERSION_CODE < 0x20343
           /* Read the cache line size from the PCI space. */
           pcibios_read_config_byte(pci_bus, pci_device_fn,
                                PCI_CACHE_LINE_SIZE, &cacheSz);
#else
        pci_read_config_byte(pdev, PCI_CACHE_LINE_SIZE, &cacheSz);
#endif

           // Cache line size is in DWORDS, calculate bytes. 
           cacheSz *= 4;

        /*
         * Check the cache line size
         */

        if ((cacheSz % 0x10) || (!cacheSz)) {
            printk(KERN_INFO "Cacheline size not proper.\n");
            cacheSz = 0x20;    //default:Use the paragraph boundary for alignment.
        }  

        /*
         * Here the Command reg is read and modified if necessary
         */

#if LINUX_VERSION_CODE < 0x20343
        pcibios_read_config_word(pci_bus, pci_device_fn,
                                 PCI_COMMAND, &pci_command);
#else
        pci_read_config_word(pdev, PCI_COMMAND, &pci_command);
#endif
        if ( (pci_command & (PCI_COMMAND_MASTER | PCI_COMMAND_INVALIDATE) )
             != (PCI_COMMAND_MASTER | PCI_COMMAND_INVALIDATE) ) {
#if LINUX_VERSION_CODE < 0x20343
            printk(KERN_INFO "The PCI BIOS has not enabled the"
                   " device at %d/%d.  Updating PCI command %4.4x->"
                   " | (PCI_COMMAND_MASTER | PCI_COMMAND_INVALIDATE).\n",
                   pci_bus, pci_device_fn, pci_command);
            pci_command |= (PCI_COMMAND_MASTER | PCI_COMMAND_INVALIDATE);
            pcibios_write_config_word(pci_bus, pci_device_fn,
                                      PCI_COMMAND, pci_command);
#else
        pci_write_config_byte(pdev, PCI_COMMAND, pci_command);
#endif
        }

        dev = tc990probe(dev, ioaddr, irq, chip_idx, pdev);

        if (!dev) break;

        /* PCI latency check (set) */
#if LINUX_VERSION_CODE < 0x20343
        pcibios_read_config_byte(pci_bus, pci_device_fn,
                                 PCI_LATENCY_TIMER, &pci_latency);
#else
        pci_read_config_byte(pdev, PCI_LATENCY_TIMER, &pci_latency);
#endif
        if (pci_latency < min_pci_latency[tc990_index]) {
            printk(KERN_INFO "  PCI latency timer (CFLT) is "
                   "unreasonably low at %d.  Setting to %d clocks.\n",
                   pci_latency, min_pci_latency[tc990_index]);

#if LINUX_VERSION_CODE < 0x20343
            pcibios_write_config_byte(pci_bus, pci_device_fn,

                            PCI_LATENCY_TIMER, min_pci_latency[tc990_index]);
#else

            pci_write_config_byte(pdev, PCI_LATENCY_TIMER, min_pci_latency[tc990_index]);
#endif
            /*
             * Save the pdev variable
             */
            ((struct tc990_private *)(dev->priv))->pdev = pdev;
            ((struct tc990_private *)(dev->priv))->index = tc990_index++;
        }
        dev = 0;
        cards_found++;
    }
	  DBGPRINT_INITIALIZE(("pci_etherdev_probe OUT: cards found = %d\n", cards_found));
    return cards_found ? 0 : -ENODEV;
}

/*----------------------------------------------------------------------
 * tc990probe --
 *  This routine is called by pci_etherdev_probe to allocate the dev structure
 *	and prepare it and the private data
 *
 * Arguments:
 *  dev     - a pointer to hold the device struture once built
 *	ioaddr  - the iobase adress of this NIC
 *	irq     - the interrupt number of this NIC
 *	chip_id - the device ID of the NIC
 *
 * Results:
 *  NULL       if failure
 *	dev			   If successful
 *----------------------------------------------------------------------
 */
static struct net_device *tc990probe ( struct net_device *dev, long ioaddr, u16 irq,
																								u16 chip_id, struct pci_dev* pdev )
{
    struct tc990_private *np;
    u16 retval;
    u32 i;

	  DBGPRINT_INITIALIZE(("tc990probe IN:\n"));

    dev = init_etherdev(dev, sizeof(struct tc990_private));

    /* Make certain the descriptor lists are aligned. */
    np = (void *)(((long)kmalloc (sizeof(*np), GFP_KERNEL) + 15) & ~15);

    if (!np) { 

        DBGPRINT_ERROR((KERN_INFO "tc990probe OUT: Failed to allocate Private data\n"));
        free_resources(dev);
        return NULL; 

    }

    memset( np, 0, sizeof(*np) );  

#ifndef USE_IO_MODE
    ioaddr = (long)ioremap(ioaddr & PCI_BASE_ADDRESS_MEM_MASK, 0x200);

    if (0 == ioaddr) {
        DBGPRINT_ERROR((KERN_INFO "tc990probe OUT: Failed to map PCI address %#lx.\n", ioaddr));
        return NULL;
   }
   np->resources_reserved |= TC990_IO_MAPPED;
#else
   ioaddr &= ~1;
#endif

    dev->base_addr = ioaddr;
    dev->irq = irq;

#if LINUX_VERSION_CODE >= 0x20343
    init_waitqueue_head(&np->wait_q);
#endif

    dev->priv = np;

    np->shared = (struct tc990_shared *) pci_alloc_consistent( np->pdev, sizeof(struct tc990_shared), &np->shared_dma_addr);

    if (!np->shared) { 
        DBGPRINT_ERROR((KERN_INFO "tc990probe OUT: Failed to allocate shared memory data\n"));
        free_resources(dev);
        return NULL; 
    }

    np->shared_size = sizeof(struct tc990_shared); 
    memset( np->shared, 0, sizeof(struct tc990_shared) );  
    np->resources_reserved |= TC990_SHARED_MEMORY_ALLOCATED;
    np->pdev = pdev;
    
    retval = init_ring_zone(dev);
    if (retval) {
        DBGPRINT_ERROR((KERN_INFO "tc990probe OUT: Failed init_ring_zone\n"));
        free_resources(dev);
        return NULL; 
    }

    

    np->chip_id = chip_id;

    spin_lock_init(&np->lock);

    /* The chip-specific entries in the device structure. */
    dev->open = &tc990_open;
    dev->hard_start_xmit = &tc990_start_tx;
    dev->stop = &tc990_close;
    dev->get_stats = &tc990_get_stats;
    dev->set_multicast_list = &tc990_set_rx_mode;
    dev->set_mac_address = &SetMacAddress;
    dev->do_ioctl = &IoctlHandler;

    if ((retval = download_runtime_image(dev))) {;
        DBGPRINT_ERROR((KERN_INFO "tc990probe OUT: Failed download_runtime_image\n"));
        free_resources(dev);
        return NULL;
    }

    if ((retval = download_boot_record(dev, tc990_WAITING_FOR_BOOT))) {
        DBGPRINT_ERROR((KERN_INFO "tc990probe OUT: Failed download_boot_record\n"));
        free_resources(dev);
        return NULL;
    }

    /* Set the maximum packet size for the firmware  */
    retval = issue_command(dev, tc990_CMD_MAX_PKT_SIZE_WRITE,
                           0x800, 0, 0, NULL, NULL, NULL, 1);
    retval |= issue_command(dev, 69, 0, 0, 0, NULL, NULL, NULL, 0); 

    if (retval) { 
        DBGPRINT_ERROR((KERN_INFO "tc990probe OUT: Failed one of two issue_command calls\n"));
        free_resources(dev);
        return NULL; 
    }

    /* Read the station address from the adapter. */
    if (ReadPermanentAddress(dev) != NIC_STATUS_SUCCESS){
        DBGPRINT_ERROR((KERN_INFO "tc990probe OUT: Failed ReadPermanentAddress\n"));
        free_resources(dev);
	      return NULL;
    }    

    // Print Identifying String to Message Log
    printk(KERN_INFO "%s: %s at %#3lx, ",
            dev->name, 
            pci_tbl[chip_id].name, 
            ioaddr
            );
    for (i = 0; i < 6; i++){
        printk("%2.2X:", dev->dev_addr[i]);
    }
    printk(", IRQ %d.\n", irq);
    
    np->next_module = root_net_dev;
    root_net_dev = dev;
    /*
     * Update the resources reserved
     */
    np->resources_reserved |= TC990_DEVICE_IN_ROOT_CHAIN;

	  DBGPRINT_INITIALIZE(("tc990probe OUT: successful\n"));
    return dev;
}

/*----------------------------------------------------------------------
 * SetTransceiverMode --
 *  This function sets the transceiver of the passed in device.  If the
 *	Option selected by the User is Valid it is used but it not then
 *	this function sets it to the default
 *
 * Arguments:
 *  dev     - a pointer to the device to set
 *
 * Results:
 *  return value from the issue_command Call
 *----------------------------------------------------------------------
 */
static u16 SetTransceiverMode(struct net_device *dev)
{
    struct tc990_private *np = (struct tc990_private *)dev->priv;
    u16 device_id = pci_tbl[np->chip_id].device_id;
		u16 subsystem_id = pci_tbl[np->chip_id].subsystem_id;

	  DBGPRINT_FUNCTION(("SetTransceiverMode IN: force = %d\n", force[np->index]));
    if ( (force[np->index] < 0) || (force[np->index] > 4) ){
        printk (KERN_WARNING "3c990: Bad value -- ""force=%x"".  Autonegotiation default used instead. \n", force[np->index]);
        force[np->index] = 4;
		}
    if (device_id == 0x9904 || device_id == 0x9905){
				if (subsystem_id & SUBSYSTEM_FIBER_MASK){
						//then this is a Fiber card and force should be set to 2 or 3
						if ((force[np->index] < 2) || (force[np->index] > 3)){
								force[np->index] = 3;
						}
				}
		}
		DBGPRINT_FUNCTION(("SetTransceiverMode OUT: card forced to = %d\n", force[np->index]));
    return issue_command(dev, tc990_CMD_XCVR_SELECT,
                         force[np->index], 0, 0, NULL, NULL, NULL, 0);
}
/*----------------------------------------------------------------------
 * tc990_open --
 *  This function is called by the Kernel when someone wants to open
 *	the device for passing data.  It gains a Interrupt and makes all of
 *	the initilizations left to allow tx and rx
 *
 * Arguments:
 *  dev     - a pointer to the device to open
 *
 * Results:
 *  -EAGAIN    if failure
 *	0		   If successful
 *----------------------------------------------------------------------
 */
static int tc990_open(struct net_device *dev)
{
    struct tc990_private *np = (struct tc990_private *)dev->priv;
    long ioaddr = dev->base_addr;
    u16 retval = 0;
	
	DBGPRINT_FUNCTION(("tc990_open IN:\n"));

    np->lock = (spinlock_t) SPIN_LOCK_UNLOCKED; 

    if (request_irq(dev->irq, &tc990_interrupt, SA_SHIRQ, dev->name, dev)){
		DBGPRINT_ERROR(("tc990_open OUT: Failed request for our interrupt\n"));
        return -EAGAIN;  
	}
    np->resources_reserved |= TC990_IRQ_RESERVED;
    
    if (WriteMacAddressToNic(dev) != NIC_STATUS_SUCCESS){
		DBGPRINT_ERROR(("tc990_open OUT: Failed to write the MAC address to the NIC\n"));
        return -EAGAIN;  
    }    

		retval = SetTransceiverMode(dev);
    retval |= issue_command(dev, tc990_CMD_TX_ENABLE,
                     0, 0, 0, NULL, NULL, NULL, 1);
    retval |= issue_command(dev, tc990_CMD_RX_ENABLE, 
                       0, 0, 0, NULL, NULL, NULL, 1);
    if (retval){
		DBGPRINT_ERROR(("tc990_open OUT: Failed to set XCVR or enable TX or RX\n"));
		return -EAGAIN;  
	}
    tc990_writel(tc990_ENABLE_ALL_INT, ioaddr + tc990_INT_ENABLE_REG); 
    tc990_writel(tc990_UNMASK_ALL_INT, ioaddr + tc990_INT_MASK_REG );

    MOD_INC_USE_COUNT;
    netif_start_queue(dev);
	DBGPRINT_FUNCTION(("tc990_open OUT: Success\n"));
    return 0;
}

/*----------------------------------------------------------------------
 * tc990_start_tx --
 *  This function is called by the Kernel to transmit a packet
 *
 * Arguments:
 *  skb     - a pointer to the socket buffer that holds the packet to TX
 *  dev     - a pointer to the device to open
 *
 * Results:
 *  1		if failure
 *	0		If successful
 *----------------------------------------------------------------------
 */
static int tc990_start_tx(struct sk_buff *skb, struct net_device *dev)
{
    struct tc990_private *np = (struct tc990_private *)dev->priv;
    unsigned long flags;
    TX_RING *pTxRing = &np->ring_info.TxLoRing;    
    u32 xmitReadIndex;
    u32 xmitWriteIndex;
    u32 xmitDescriptorSpace;
    TX_DESC *pXmitWritePtr;
    TX_FRAME_DESC *pFramePtr;
    unsigned long addr;
	
	DBGPRINT_SEND(("tc990_start_tx IN:\n"));
    /* 
     * Block a timer-based transmit from overlapping.  This could better 
     * be done with atomic_swap(1, dev->tbusy), but set_bit() works i
     * as well
     */
#if LINUX_VERSION_CODE < 0x20343
    if ( (test_and_set_bit(0, (void*)&dev->tbusy) != 0)){ 
		DBGPRINT_ERROR(("tc990_start_tx OUT: Failed TX busy bit still set\n"));
        return 1;
	}
#endif

    spin_lock_irqsave(&np->lock, flags);

    xmitReadIndex = pTxRing->LastReadUL;
    xmitWriteIndex = pTxRing->LastWriteUL;

    if ( xmitWriteIndex >= xmitReadIndex )
        xmitDescriptorSpace = (sizeof(TX_DESC)*TX_ENTRIES) -
                              (xmitWriteIndex - xmitReadIndex);
    else
        xmitDescriptorSpace =  xmitReadIndex - xmitWriteIndex;
    
    if (xmitDescriptorSpace < (4 * sizeof(TX_DESC))) {

        np->tx_full  = 1;
        netif_stop_queue(dev);
        spin_unlock_irqrestore(&np->lock, flags);
		DBGPRINT_ERROR(("tc990_start_tx OUT: Failed TX ring out of space\n"));
        return 1;

    }

    pXmitWritePtr = (TX_DESC *)(pTxRing->RingBase + xmitWriteIndex);
    pFramePtr = (TX_FRAME_DESC *) pXmitWritePtr;

    pFramePtr->frU.frFlagsS.frFlagsUC = FRAME_TYPE_PKT_HDR;
    pFramePtr->pktPtrLoUL = (unsigned long)skb;
    pFramePtr->pktPtrHiUL = upper_bits(skb); // 0 on 32 bit computers

    update_tx_ring_index(&xmitWriteIndex);
    pXmitWritePtr = (TX_DESC *)(pTxRing->RingBase + xmitWriteIndex); 

    pXmitWritePtr->fragLenUW = (u16)skb->len;
    pXmitWritePtr->fragFlagsUC = FRAME_TYPE_FRAG_HDR | HOST_DESC_VALID;
    pXmitWritePtr->fragReservedUC = 0;
    pXmitWritePtr->fragSpareUL = 0;

    addr = pci_map_single(np->pdev, skb->data, skb->len, PCI_DMA_TODEVICE);

    pXmitWritePtr->fragHostAddrLoUL =  addr;
    pXmitWritePtr->fragHostAddrHiUL =  upper_bits((void*)addr);// 0 on 32 bit computers

    pFramePtr->frU.frFlagsS.frFlagsUC |= HOST_DESC_VALID;
    pFramePtr->frU.frFlagsS.frNumDescUC = 1;
    pFramePtr->frU.frFlagsS.frPktLen = (u16)skb->len;
    update_tx_ring_index(&xmitWriteIndex);

    pTxRing->LastWriteUL = xmitWriteIndex;
    tc990_writel(pTxRing->LastWriteUL, dev->base_addr + pTxRing->WriteRegister);

    spin_unlock_irqrestore(&np->lock, flags);
#if LINUX_VERSION_CODE < 0x20343
    clear_bit(0, (void*)&dev->tbusy);    
#endif
    dev->trans_start = jiffies;

	DBGPRINT_SEND(("tc990_start_tx OUT:  Success\n"));
    return 0;
}

/*----------------------------------------------------------------------
 * tc990_interrupt --
 *  This function is called by the Kernel when the NIC raises and Interrupt
 *
 * Arguments:
 *  irq				- the interrupt that was raised
 *  dev_instance    - a pointer to the device raising the interrupt
 *  rgs				- unused
 *
 * Results:
 *	none
 *----------------------------------------------------------------------
 */
static void tc990_interrupt(int irq, void *dev_instance, struct pt_regs *rgs)
{
    struct net_device *dev = (struct net_device *)dev_instance;
    struct tc990_private *np;
    volatile u32 intr_status; 
    volatile u32 *rxReadIndex;
    volatile u32 *rxWriteIndex;
    long ioaddr; 
    volatile u32 *xmitReadIndex;
	DBGPRINT_INTERRUPT(("tc990_interrupt IN:\n"));

    ioaddr = dev->base_addr;
    np = (struct tc990_private *)dev->priv;

    spin_lock(&np->lock); 

    /* mask all the interrupts */

    tc990_writel(tc990_MASK_ALL_INT, ioaddr + tc990_INT_MASK_REG);

    intr_status = tc990_readl(ioaddr + tc990_INT_STATUS_REG);

      while (1) {

        tc990_writel(intr_status, ioaddr + tc990_INT_STATUS_REG);

	    if (!intr_status) break;
 


        rxReadIndex =  &np->shared->var.hvWriteS.regRxHiReadUL;
        rxWriteIndex = &np->shared->var.hvReadS.regRxHiWriteUL;
        if(*rxReadIndex != *rxWriteIndex){
         	process_receive(dev, &np->ring_info.RxHiRing, rxReadIndex, 
                        rxWriteIndex );
		}
        /* Check the Low ring */
        rxReadIndex =  &np->shared->var.hvWriteS.regRxLoReadUL;
        rxWriteIndex = &np->shared->var.hvReadS.regRxLoWriteUL;        
        if (*rxReadIndex != *rxWriteIndex){
            process_receive(dev, &np->ring_info.RxLoRing, rxReadIndex, 
                            rxWriteIndex);
		}
        /* check the transmit ring */
        xmitReadIndex = &np->shared->var.hvReadS.regTxLoReadUL;

        if (np->ring_info.TxLoRing.LastReadUL != *xmitReadIndex){
            process_send_complete(dev, &np->ring_info.TxLoRing, xmitReadIndex);
		}
		/* check the response ring if someone is not waiting for a response*/
        //check if any locks are on waiting_for_response 
 		if(np->waiting_for_response == 0){
			if ( np->shared->var.hvWriteS.regRespReadUL != 
				np->shared->var.hvReadS.regRespWriteUL){
 				process_response( np, np->shared->var.hvWriteS.regRespReadUL, 0 );
			}
		}	
        intr_status = tc990_readl(ioaddr + tc990_INT_STATUS_REG);

    } 
    
    /* unmask all the interrupts */
    tc990_writel(tc990_UNMASK_ALL_INT, ioaddr + tc990_INT_MASK_REG );    
    spin_unlock(&np->lock);       

	DBGPRINT_INTERRUPT(("tc990_interrupt OUT: Success\n"));
    return;
}

/*----------------------------------------------------------------------
 * process_receive --
 *  This function is called by the inturrupt handler to process any
 *	packets that may have been recieved.  After passing the packets to 
 *	the Kernel, this function refills the receive buffer ring
 *
 * Arguments:
 *  dev    - a pointer to the device raising the interrupt
 *  pRxRing	- pointer to the recieve ring to process
 *  regRxReadUL	- the index in the ring for the drivers next read
 *  regRxWriteUL - the index in the ring for the firmware's next write
 *
 * Results:
 *	none
 *----------------------------------------------------------------------
 */
static void process_receive(struct net_device *dev, tc990_RING *pRxRing,
                    volatile u32 *regRxReadUL, volatile u32 *regRxWriteUL)
{
    struct sk_buff *skb;
    RX_DSC  *rxDescriptor ;

    u32 slotIndex, rxReadIndex = *regRxReadUL, writeVal = *regRxWriteUL;
    u32 rxBufferSize =  ETHERNET_MAXIMUM_FRAME_SIZE + 4; 

    struct tc990_private *np = (struct tc990_private *)dev->priv;
    u16 count = 0; 
    DMA_ADDR addr;
		DBGPRINT_RECEIVE(("process_receive IN:\n"));

    while ( rxReadIndex != writeVal ){

        rxDescriptor = (RX_DSC*)(pRxRing->RingBase + rxReadIndex);
        slotIndex   = rxDescriptor->virtual_addr_lo;

        if (!rxDescriptor->RxStatus ) {

            skb = np->slot[slotIndex].skb;
            if (skb){  
						    addr = (DMA_ADDR)rebuild_address(np->slot[slotIndex].physical_addr_hi,
																				np->slot[slotIndex].physical_addr_lo);
								pci_unmap_single(np->pdev, addr,
											np->slot[slotIndex].buffer_length, PCI_DMA_FROMDEVICE);

                skb_put(skb, rxDescriptor->FrameLength);
                skb->protocol = eth_type_trans(skb, dev);
#ifdef NICE_SUPPORT
        				if( np->nice_rx )
        					np->nice_rx(skb, np->nice_ctx);
        				else
        					netif_rx(skb);
#else  /* !NICE_SUPPORT */
         				netif_rx(skb);
#endif /* NICE_SUPPORT */
                dev->last_rx = jiffies;
            }
        }

        UPDATE_INDEX( rxReadIndex, sizeof( RX_DSC ), RX_ENTRIES );
        writeVal = *regRxWriteUL;
        count++; 
   }

    /* Refill buffer slots */
    rxReadIndex = *regRxReadUL;
    while ( rxReadIndex != writeVal ) {

        /* Give this receive descriptor back to firmware. */
        rxDescriptor = (RX_DSC*)(pRxRing->RingBase + rxReadIndex);
        slotIndex   = rxDescriptor->virtual_addr_lo;

        UPDATE_INDEX( rxReadIndex, sizeof( RX_DSC ), RX_ENTRIES );
        *regRxReadUL = rxReadIndex ;

        if ((skb = dev_alloc_skb(rxBufferSize)) == NULL) {
            printk(KERN_CRIT "3c990: Memory squeeze (alloc rx buff failed) Danger!\n"); 
						DBGPRINT_ERROR(("process_receive OUT: Failed alloc rx buff failed Danger!\n"));
            return; 
        }
        skb->dev = dev;
				DBGPRINT_RECEIVE((KERN_CRIT "*A:Data %p; tail %p; ", skb->data, skb->tail));
				DBGPRINT_RECEIVE((KERN_CRIT "Head %p; end %p \n", skb->head, skb->end));

        /* Save the information in the slot. */
        np->slot[slotIndex].skb = skb;

        /* Add the pci unmap code */
				addr = pci_map_single(np->pdev, skb->tail, rxBufferSize, PCI_DMA_FROMDEVICE);
				np->slot[slotIndex].physical_addr_lo =  addr;
				np->slot[slotIndex].physical_addr_hi =  upper_bits((void*)addr);// 0 on 32 bit computers

        np->slot[slotIndex].buffer_length      = rxBufferSize;
        release_buf_to_firmware(dev, slotIndex );
				DBGPRINT_RECEIVE((KERN_CRIT "*B:Data %p; tail %x=%p; ", skb->data, slotIndex, skb->tail));
				DBGPRINT_RECEIVE((KERN_CRIT "Head %p; end %p \n", skb->head, skb->end));
    }
	DBGPRINT_RECEIVE(("process_receive OUT: Success\n"));
} 

/*----------------------------------------------------------------------
 * release_buf_to_firmware --
 *  This function releases the specified buffer to the firmware so the
 *	firmware can put new recieves into the buffer
 *
 * Arguments:
 *  dev    - a pointer to the device to release the buffer to
 *  slot_index	- index into an array of receive buffers
 *
 * Results:
 *	none
 *----------------------------------------------------------------------
 */
static void release_buf_to_firmware( struct net_device *dev, u32 slot_index )
{
    RX_FREE_DSC *rxFreeDescriptor;
    HOST_VAR_S *pHostVar;
    struct tc990_private *np = (struct tc990_private *)dev->priv;    
	DBGPRINT_RECEIVE(("release_buf_to_firmware IN:\n"));
    
    pHostVar = (HOST_VAR_S*)bus_to_virt((unsigned long)np->shared->init.hostVarsPS);
    
    rxFreeDescriptor = (RX_FREE_DSC*)(np->ring_info.RxBuffRing.RingBase + pHostVar->hvWriteS.regRxBuffWriteUL);
    
    rxFreeDescriptor->physical_addr_lo =np->slot[slot_index].physical_addr_lo;
    rxFreeDescriptor->physical_addr_hi =np->slot[slot_index].physical_addr_hi;
    rxFreeDescriptor->virtual_addr_lo = slot_index;
    rxFreeDescriptor->virtual_addr_hi = 0; 
    
    UPDATE_INDEX( pHostVar->hvWriteS.regRxBuffWriteUL, sizeof( RX_FREE_DSC ), RX_ENTRIES );

	DBGPRINT_RECEIVE(("release_buf_to_firmware OUT: Success\n"));
}


/*----------------------------------------------------------------------
 * process_response -- 
 *  This routine is called to find a responce in the responce ring and/or
 *	to clean out the response ring.  If the Command Parameter passed in is
 *	zero then the routine looks for a read stats command otherwise it looks 
 *	for the command number passed in.  
 *
 * Arguments:
 *  np     - Pointer to the device private structure of the NIC 
 *	responseReadIndex - holds the number of the command to send to Firmware
 *	Command - holds the number of the command to search for
 *
 * Results:
 *  1			If Error	
 *	0			If successful 
 *----------------------------------------------------------------------
 */
static u8 process_response( struct tc990_private *np, u32 responseReadIndex, 
                           u16 Command )
{
    RESPONSE_DSC* responseDesc;
    
	DBGPRINT_CMD_RSP_RING(("        process_response IN for command %x\n", Command));
    while ( responseReadIndex !=  np->shared->var.hvReadS.regRespWriteUL ){
        responseDesc = (RESPONSE_DSC*)(np->ring_info.RspRing.RingBase + responseReadIndex);
        
        if ( Command == responseDesc->nrml.Command ){ 
			DBGPRINT_CMD_RSP_RING(("        process_response OUT found command %x\n", Command));
            return tc990_STATUS_CMD_FOUND; 
	    }
        if (responseDesc->nrml.Command == tc990_CMD_READ_STATS){ 
            stats_handler( np );
            responseReadIndex =  np->shared->var.hvWriteS.regRespReadUL;
			DBGPRINT_CMD_RSP_RING(("        process_response OUT found command tc990_CMD_READ_STATS\n"));
	    	return 0;
        }else{
            if ( responseDesc->nrml.Flags & RESPONSE_DSC_ERROR_SET ) 
                printk(KERN_WARNING "        tc990: Response error bit set \n");
            UPDATE_INDEX( np->shared->var.hvWriteS.regRespReadUL,
                          sizeof(RESPONSE_DSC), RESPONSE_ENTRIES );
            responseReadIndex =  np->shared->var.hvWriteS.regRespReadUL;
        }
    }
	DBGPRINT_CMD_RSP_RING(("        process_response OUT Ring empty for command %x\n", Command));
	return 0;
}

/*----------------------------------------------------------------------
 * process_send_complete --
 *  This function is called by the interrupt handler to acknowledge that 
 *	packets were transmitted by the NIC and free the skb strutures
 *
 * Arguments:
 *  dev     - a pointer to the device to open
 *  pTxRing     - pointer to the tx ring to acknowledge
 *  xmitReadIndex - current read Index on the tx ring pTxRing
 *
 * Results:
 *  none
 *----------------------------------------------------------------------
 */
static void process_send_complete(struct net_device *dev, TX_RING *pTxRing, volatile u32 *xmitReadIndex)    
{
    TX_FRAME_DESC *pXmitReadPtr;
    struct sk_buff *skb;
    struct tc990_private *np = (struct tc990_private *)dev->priv;
		DMA_ADDR addr;
		DBGPRINT_SEND(("process_send_complete IN:\n"));

    while (pTxRing->LastReadUL != *xmitReadIndex) {
		pXmitReadPtr = (TX_FRAME_DESC *)(pTxRing->RingBase + pTxRing->LastReadUL);

        if(pXmitReadPtr->frU.frFlagsS.frFlagsUC & FRAME_TYPE_PKT_HDR) {
				    addr = (DMA_ADDR)rebuild_address(pXmitReadPtr->pktPtrHiUL,
																				pXmitReadPtr->pktPtrLoUL);
						pci_unmap_single(np->pdev, addr, pXmitReadPtr->frU.frFlagsS.frPktLen, PCI_DMA_TODEVICE);
						skb = (struct sk_buff *)rebuild_address(pXmitReadPtr->pktPtrHiUL, pXmitReadPtr->pktPtrLoUL);
            dev_kfree_skb_irq(skb);
        }
        update_tx_ring_index(&pTxRing->LastReadUL);
    }
    if (np->tx_full){
        np->tx_full = 0;
        netif_wake_queue(dev); /* Attention: under a spinlock.  --SAW */
    }
		DBGPRINT_SEND(("process_send_complete OUT: Success\n"));
}

/*----------------------------------------------------------------------
 * stats_handler -- 
 *  This routine is called to process the stats being pushed up by the 
 *	Firmware.  It takes these stats and populatres the device structure 
 *	with them.
 *
 * Arguments:
 *  np   - Pointer to the device private structure of the NIC 
 *
 * Results:
 *  none
 *----------------------------------------------------------------------
 */
static void stats_handler( struct tc990_private  *np )
{    
    RESPONSE_DSC* responseDescriptor;
 	DBGPRINT_CMD_RSP_RING(("            stats_handler IN:\n"));
   
    responseDescriptor = (RESPONSE_DSC*) (np->ring_info.RspRing.RingBase + 
                         np->shared->var.hvWriteS.regRespReadUL);

    if ( responseDescriptor->nrml.Flags & RESPONSE_DSC_ERROR_SET ) {
        printk(KERN_WARNING "3c990: Stats error flag set.\n" ); 
 		DBGPRINT_ERROR(("            stats_handler OUT: Stats error flag set\n"));
        return;

    }

    np->stats.tx_packets = responseDescriptor->tx.pkt; 
#if LINUX_VERSION_CODE > 0x20024
    np->stats.tx_bytes = responseDescriptor->tx.byte;
#endif

    UPDATE_INDEX( np->shared->var.hvWriteS.regRespReadUL, sizeof(RESPONSE_DSC),
                  RESPONSE_ENTRIES );
    responseDescriptor = (RESPONSE_DSC*) (np->ring_info.RspRing.RingBase + 
                          np->shared->var.hvWriteS.regRespReadUL );

    UPDATE_INDEX(np->shared->var.hvWriteS.regRespReadUL, sizeof(RESPONSE_DSC),
                 RESPONSE_ENTRIES );

    responseDescriptor = (RESPONSE_DSC*) (np->ring_info.RspRing.RingBase + 
                         np->shared->var.hvWriteS.regRespReadUL );

    np->stats.tx_carrier_errors = responseDescriptor->txCrit.carrierLost;
    np->stats.collisions = responseDescriptor->txCrit.multCollision;
    np->stats.tx_errors = responseDescriptor->txCrit.carrierLost;        
    
    UPDATE_INDEX(np->shared->var.hvWriteS.regRespReadUL, sizeof(RESPONSE_DSC), 
                 RESPONSE_ENTRIES );

    responseDescriptor = (RESPONSE_DSC*) (np->ring_info.RspRing.RingBase + 
                          np->shared->var.hvWriteS.regRespReadUL );
 
    np->stats.rx_packets = responseDescriptor->txRx.rxPkt;
#if LINUX_VERSION_CODE > 0x20024
    np->stats.rx_bytes = responseDescriptor->txRx.rxByte;
#endif
    
    UPDATE_INDEX(np->shared->var.hvWriteS.regRespReadUL, sizeof(RESPONSE_DSC),
                  RESPONSE_ENTRIES );
    responseDescriptor = (RESPONSE_DSC*) (np->ring_info.RspRing.RingBase + 
                         np->shared->var.hvWriteS.regRespReadUL );    

    np->stats.rx_fifo_errors = responseDescriptor->rx.fifoOverrun;
    np->stats.rx_errors = responseDescriptor->rx.fifoOverrun;
    np->stats.rx_errors += responseDescriptor->rx.badSSD;
    np->stats.rx_errors += responseDescriptor->rx.crcError;
    np->stats.rx_crc_errors = responseDescriptor->rx.crcError;
    
    UPDATE_INDEX( np->shared->var.hvWriteS.regRespReadUL, 
                  sizeof( RESPONSE_DSC ), RESPONSE_ENTRIES );
    responseDescriptor = (RESPONSE_DSC*) 
        (np->ring_info.RspRing.RingBase + np->shared->var.hvWriteS.regRespReadUL );
    np->stats.rx_length_errors = responseDescriptor->rxGeneral.oversize;    

    UPDATE_INDEX( np->shared->var.hvWriteS.regRespReadUL, 
                  sizeof( RESPONSE_DSC ), RESPONSE_ENTRIES );
    responseDescriptor = (RESPONSE_DSC*) 
        (np->ring_info.RspRing.RingBase + np->shared->var.hvWriteS.regRespReadUL );
    
    UPDATE_INDEX(np->shared->var.hvWriteS.regRespReadUL, sizeof(RESPONSE_DSC), 
                 RESPONSE_ENTRIES );
    responseDescriptor = (RESPONSE_DSC*) (np->ring_info.RspRing.RingBase + 
                         np->shared->var.hvWriteS.regRespReadUL );

    wake_up_interruptible(&np->wait_q);
 	DBGPRINT_CMD_RSP_RING(("            stats_handler OUT: Success\n"));
}

/*----------------------------------------------------------------------
 * tc990_get_stats -- 
 *  This routine is called by the Kernel to retreive the stats of
 *	the NIC.  It isses a command and waits for the responce and then 
 *	returns a pointer to the Stats
 *
 * Arguments:
 *  dev     - Pointer to the device to get the stats of
 *
 * Results:
 *  static struct net_device_stats - pointer to the Stats
 *----------------------------------------------------------------------
 */
static struct net_device_stats *tc990_get_stats(struct net_device *dev)
{
    u16 errVal = 0;  
    unsigned long flags;
    struct tc990_private *np = (struct tc990_private *)dev->priv;
	DBGPRINT_FUNCTION(("tc990_get_stats IN\n"));

    if (netif_running(dev)) {
		spin_lock_irqsave(&np->lock, flags); 
        errVal = issue_command( dev, (u16)tc990_CMD_READ_STATS,
                               0, 0, 0, NULL, NULL, NULL, 0 ); 
        
		spin_unlock_irqrestore(&np->lock, flags); 
        if (errVal){
			printk(KERN_CRIT "3c990: Stats command gone BAD." );
		}
        interruptible_sleep_on_timeout( &np->wait_q, HZ);
    }
	DBGPRINT_FUNCTION(("tc990_get_stats OUT: Success\n"));
    return &np->stats;
}

/*----------------------------------------------------------------------
 * tc990_set_rx_mode -- 
 *  This routine is called by the Kernel to change the multicast list
 *
 * Arguments:
 *  dev     - Pointer to the device to change
 *
 * Results:
 *  none
 *----------------------------------------------------------------------
 */
static void tc990_set_rx_mode(struct net_device *dev)
{
    u32 filter = 0;
    u32 Crc, Carry;
    u16 i, j;
    u8 ThisByte;
    u8 Address[6];
    u32 hashFilterArray[(tc990_MULTICAST_BITS + 1) / 32];
    u32 hashBit, count;
	DBGPRINT_FUNCTION(("tc990_set_rx_mode IN\n"));

    if (dev->flags & IFF_PROMISC) {       /* Set promiscuous. log net taps */
        printk(KERN_NOTICE "%s: Promiscuous mode enabled.\n", dev->name);
        filter |= tc990_RX_FILT_PROMISCUOUS;
    } 
    else if (dev->flags & IFF_ALLMULTI) {
        filter |= tc990_RX_FILT_DIRECTED; 
        filter |= tc990_RX_FILT_ALL_MULTICAST;
        filter |= tc990_RX_FILT_BROADCAST;
    }
    else if (dev->flags & IFF_MULTICAST) {
        filter |= tc990_RX_FILT_DIRECTED;
        filter |= tc990_RX_FILT_HASH_MULTICAST;
        filter |= tc990_RX_FILT_BROADCAST;
        /*
         *SetMulticastAddressList on the adapter.
         * Clear all bits   
         */
        memset( hashFilterArray, 0, sizeof( hashFilterArray ) ); 
        /* 
         * Calculate hash bit for eash address and stuff in bit array*/

        for ( count = 0; count < dev->mc_count; count++ ) {            
            /* CalculateHashBits */
            /* Compute CRC for the address value  */
            Crc = 0xffffffff;  // initial value 
            /* For each byte of the address */
            for ( i = 0; i < 6; i++ ) {
                ThisByte = Address[i];
                /* For each bit in the byte */
                for ( j = 0; j < 8; j++ ) {
                    Carry = ((Crc & 0x80000000) ? 1 : 0) ^ (ThisByte & 0x01);
                    Crc  <<= 1;
                    ThisByte >>= 1;
                    if ( Carry )
                        Crc = (Crc ^ POLYNOMIAL) | Carry;
                }
            }
            /* filter bit position  */
            hashBit = (u16)(Crc & tc990_MULTICAST_BITS) ;            
            hashFilterArray[ hashBit / 32 ] |=  ( 1 << hashBit % 32 ) ;
        }
        i = issue_command( dev, (u16)tc990_CMD_MCAST_HASH_MASK_WRITE,
                          (u16)2, hashFilterArray[0], hashFilterArray[1], 
                          NULL,  NULL,  NULL,  0 ); 
    }
    else {
        filter |= tc990_RX_FILT_DIRECTED;
        filter |= tc990_RX_FILT_BROADCAST;
    }
    i = issue_command(dev, (u16)tc990_CMD_RX_FILT_WRITE,
                     (u16)filter, 0, 0, NULL, NULL, NULL, 0); 
	
	DBGPRINT_FUNCTION(("tc990_set_rx_mode OUT: success\n"));
}

/*----------------------------------------------------------------------
 * tc990_close -- 
 *  This routine is called by the Kernel to change the multicast list
 *
 * Arguments:
 *  dev     - Pointer to the device to change
 *
 * Results:
 *  none
 *----------------------------------------------------------------------
 */
static int tc990_close(struct net_device *dev)
{
    u16 errVal; 
    long ioaddr = dev->base_addr; 
	DBGPRINT_FUNCTION(("tc990_close IN\n"));

    netif_stop_queue(dev);

    /* Disable interrupts by clearing the interrupt mask. */
    tc990_writel(tc990_MASK_ALL_INT, ioaddr + tc990_INT_MASK_REG);
    /* Stop the chip's Tx and Rx processes. */
    errVal = issue_command(dev, tc990_CMD_TX_DISABLE,
                          0, 0, 0, NULL, NULL, NULL, 1);
    errVal |= issue_command(dev, tc990_CMD_RX_DISABLE,
                           0, 0, 0, NULL, NULL, NULL, 1);
    if (errVal){
		printk(KERN_CRIT "3c990: Unaccounted for failure of command to network adapter. DANGER!");
	}
    free_irq(dev->irq, dev);

    MOD_DEC_USE_COUNT;
	DBGPRINT_FUNCTION(("tc990_close OUT: success\n"));
    return 0;
}

#ifdef MODULE
#if (LINUX_VERSION_CODE < 0x02032a)
int init_module(void)
{
    return tc990_init_module();
}

void cleanup_module(void)
{
    tc990_cleanup_module();
}
#else
module_init(tc990_init_module);
module_exit(tc990_cleanup_module);
#endif
#endif

#ifdef MODULE

 int tc990_init_module(void)
{
    printk(KERN_INFO "%s", version);
    return pci_etherdev_probe(NULL, pci_tbl);

}

/*----------------------------------------------------------------------
 * tc990_cleanup_module -- 
 *  This routine is called by the Kernel to allow the module to cleanup
 *	before it is unloaded from the system memory
 *
 * Arguments:
 *  none
 *
 * Results:
 *  none
 *----------------------------------------------------------------------
 */
void tc990_cleanup_module(void)
{
    struct net_device *next_dev;
    u16 index;
	DBGPRINT_FUNCTION(("tc990_close IN\n"));

    /* No need to check MOD_IN_USE, as sys_delete_module() checks. */

    while (root_net_dev) {
        struct tc990_private *np=(struct tc990_private *)root_net_dev->priv;

        next_dev = np->next_module;

        unregister_netdev(root_net_dev);

#ifndef USE_IO_MODE
        iounmap((char *)root_net_dev->base_addr);
#endif

        /* Free all receive buffers in the receive buffer descriptor ring. */
        for  ( index = 0 ; index < RX_ENTRIES - 1; index++ ) {
            if (np->slot[index].skb != NULL) {
                dev_kfree_skb(np->slot[index].skb);
            }
            np->slot[index].physical_addr_lo = 0;
            np->slot[index].physical_addr_hi = 0;
        }

        pci_free_consistent(np->pdev, np->slot_memory_size,
                            np->slot, np->slot_physical);
        pci_free_consistent(np->pdev, np->shared_size,
                            np->shared, np->shared_dma_addr);

        kfree(np);
        kfree(root_net_dev);
        root_net_dev = next_dev;
    }
	DBGPRINT_FUNCTION(("tc990_close OUT: Success\n"));
}

#endif  // * MODULE *

/*----------------------------------------------------------------------
 * free_resources -- 
 *  This routine is called by the Kernel to free all resources from the 
 *	device because of a error
 *
 * Arguments:
 *  dev     - Pointer to the device to free resources from
 *
 * Results:
 *  none
 *----------------------------------------------------------------------
 */
static void free_resources(struct net_device *dev)
{
    u16 index;
    struct tc990_private *np=(struct tc990_private *)dev->priv;
	DBGPRINT_ERROR(("free_resources IN\n"));


    printk(KERN_INFO"3c990: There appear to be inadequate resources at this time and on this machine for this driver.  Killing further initialization. \n" );

    if (!np){
		DBGPRINT_ERROR(("free_resources OUT: Success no resources to free\n"));
		return;
	}
    unregister_netdev(dev);

    if (np->resources_reserved & TC990_DEVICE_IN_ROOT_CHAIN) {
        root_net_dev = np->next_module;
    }

#ifndef USE_IO_MODE
    if (np->resources_reserved & TC990_IO_MAPPED)
        iounmap((char *)dev->base_addr);
#endif

    if (np->resources_reserved & TC990_SLOT_MEMORY_ALLOCATED) {

        /* Free all the receive buffers */
        if (np->slot){
            for( index = 0 ; index < RX_ENTRIES - 1; index++ ) {

                if (np->slot[index].skb != NULL) {
                    dev_kfree_skb(np->slot[index].skb);
                }

                np->slot[index].physical_addr_lo = 0;
                np->slot[index].physical_addr_hi = 0;
            }
        }
        pci_free_consistent(
            np->pdev, 
            np->slot_memory_size,
            np->slot,
            np->slot_physical
            );
    }
    if (np->resources_reserved & TC990_SHARED_MEMORY_ALLOCATED) {
        pci_free_consistent(
            np->pdev,
            sizeof(struct tc990_shared),
            np->shared,
            np->shared_dma_addr
            );    
    }

    kfree(np);
    kfree(dev);
	DBGPRINT_ERROR(("free_resources OUT: Success\n"));
    return;
}

/*----------------------------------------------------------------------
 * issue_command -- 
 *  This routine is called to add a command to the command ring.  If a 
 *	response is asked for then this routine polls the responce ring for
 *	a set number of times until it gets a response.  It then fills in the
 *	three response paramaters with whatever nonzero data is sent by the 
 *	Firmware.  These commands must be formatted according to the Spec.
 *
 * Arguments:
 *  dev     - Pointer to the device structure of the NIC 
 *	Command - holds the number of the command to send to Firmware
 *	Parameter1 - holds the first parramater to send to firmare, only 16 bits
 *	Parameter2 - holds the second parramater to send to firmare, 32 bits
 *	Parameter3 - holds the third parramater to send to firmare, 32 bits
 *	Return1 - recieves the first responce parameter passed by the Firmware, 16 bits
 *	Return2 - recieves the second responce parameter passed by the Firmware, 32 bits
 *	Return3 - recieves the third responce parameter passed by the Firmware, 23 bits
 *	WaitForResponse - if nonzero then issue_command looks for a responce 
 *
 * Results:
 *	tc990_CMD_ERROR_TIMEOUT If the a responce is asked for and it times out waiting
 *  1			If Error	
 *	0			If successful 
 *----------------------------------------------------------------------
 */
static u16 issue_command(struct net_device *dev, u16 Command, u16 Parameter1,
u32 Parameter2, u32 Parameter3, u16 *Return1, u32 *Return2, u32 *Return3, 
u8 WaitForResponse) {

	struct tc990_private *np = (struct tc990_private *)dev->priv;
	CMD_DSC*      commandDescriptor;
	RESPONSE_DSC* responseDescriptor;
	u32 count, responseStatus;
	long ioaddr = dev->base_addr; 
    int index = 0;

	//Spin here until you can get a unique lock on waiting for responce
	//This code limits the number of processers that can be in this function to 16
	for (index = 0; 1; index++){
		if(test_and_set_bit(index, (void*) &np->waiting_for_response) == 0){
			break;
		}
		if(index >= 16){
			index = 0;
		}
	}

	DBGPRINT_CMD_RSP_RING(("    issue_command IN command number %x\n", Command));
	commandDescriptor = (CMD_DSC*) (np->ring_info.CmdRing.RingBase + 
				np->ring_info.CmdRing.LastWriteUL );
	memset(commandDescriptor, 0, sizeof( CMD_DSC )); 

	if ( WaitForResponse )   /* Check if wait for response is needed.*/
			/*
		* Set the flag indicating the need for a response 
		* to the command.
		*/
		responseStatus = CMD_DSC_RESPONSE_NEEDED;
	else
		responseStatus = CMD_DSC_RESPONSE_NOT_NEEDED;

	commandDescriptor->Command       = Command;
	commandDescriptor->num_descriptor = 0;
	commandDescriptor->Parameter1    = Parameter1;
	commandDescriptor->Parameter2    = Parameter2;
	commandDescriptor->Parameter3    = Parameter3;
	commandDescriptor->Flags         = CMD_DSC_FRAME_VALID 
				| responseStatus | CMD_DSC_TYPE_CMD_FRAME ; 
	commandDescriptor->SequenceNo    = 0x11;

	UPDATE_INDEX( np->ring_info.CmdRing.LastWriteUL, sizeof( CMD_DSC ), 
				CMD_ENTRIES) ; 

	tc990_writel(np->ring_info.CmdRing.LastWriteUL, ioaddr + tc990_HostTo3XP_COMM_2_REG);

	if ( WaitForResponse ) {    /* Check for response */

		for ( count = 0; count < tc990_WAIT_COUNTER; count++ ){
			/* 
			* If firmware has posted the response then break from loop
			*/
			if ( np->shared->var.hvWriteS.regRespReadUL != 
				np->shared->var.hvReadS.regRespWriteUL ){
				if(tc990_CMD_READ_STATS==commandDescriptor->Command){
					process_response (np, np->shared->var.hvWriteS.regRespReadUL, 0);
					DBGPRINT_CMD_RSP_RING(("    issue_command OUT recieved responce for CMD_READ STATS\n"));
					//Clear the unigue lock on waiting for response obtained at begining of issue_command
					clear_bit(index, (void*) &np->waiting_for_response);
					return 0;
				}
				if (tc990_STATUS_CMD_FOUND == process_response 
					(np, np->shared->var.hvWriteS.regRespReadUL, 
					(u16)commandDescriptor->Command))               
					break;
			}
			udelay(50);  
		}
		/*
		* If no response for tc990_WAIT_COUNTER, return failure.
		*/

		if ( count >= tc990_WAIT_COUNTER ){ 
			DBGPRINT_ERROR(("    issue_command OUT on Timout command number %x\n", Command));
			//Clear the unigue lock on waiting for response obtained at begining of issue_command
			clear_bit(index, (void*) &np->waiting_for_response);
			return tc990_CMD_ERROR_TIMEOUT;
		}
		responseDescriptor = (RESPONSE_DSC*) (np->ring_info.RspRing.RingBase + 
				np->shared->var.hvWriteS.regRespReadUL);
		if ( responseDescriptor->nrml.Flags & RESPONSE_DSC_ERROR_SET ) {
			DBGPRINT_ERROR(("    issue_command OUT recieved Error Responce on command number %x\n",
					 Command));
			//Clear the unigue lock on waiting for response obtained at begining of issue_command
			clear_bit(index, (void*) &np->waiting_for_response);
			return 1;
		}
		/* Command is successful, pass the response results back. */
		if ( Return1 ) *Return1 = (u16)responseDescriptor->nrml.Parameter1;
		if ( Return2 ) *Return2 = responseDescriptor->nrml.Parameter2;
		if ( Return3 ) *Return3 = responseDescriptor->nrml.Parameter3;
		UPDATE_INDEX(np->shared->var.hvWriteS.regRespReadUL, 
				sizeof( RESPONSE_DSC ), RESPONSE_ENTRIES);
		DBGPRINT_CMD_RSP_RING(("    issue_command: recieved responce on command number %x\n",
					 Command));
	}
	DBGPRINT_CMD_RSP_RING(("    issue_command OUT success on command number %x\n", Command));
    //Clear the unigue lock on waiting for response obtained at begining of issue_command 
	clear_bit(index, (void*) &np->waiting_for_response);
	return 0;
}

/*----------------------------------------------------------------------
 * reset_adapter --
 *  This routine resets the adapter pointed to by dev
 *
 * Arguments:
 *  dev     - a pointer to the device to reset
 *
 * Results:
 *  1		if failure
 *	0		If successful
 *----------------------------------------------------------------------
 */
static u16 reset_adapter(struct net_device *dev)
{
    u32  count;
    long ioaddr = dev->base_addr;
	DBGPRINT_FUNCTION(("reset_adapter IN:\n"));

    tc990_writel(tc990_RESET_ALL, ioaddr + tc990_SOFT_RESET_REG);
    udelay(10);     // Give the board some time to adjust
    tc990_writel(0,    ioaddr + tc990_SOFT_RESET_REG);   
    for ( count = 0; count < tc990_WAIT_COUNTER; count++ ) {
        if ( tc990_readl(ioaddr + tc990_3XP2HOST_COMM_0_REG) == 
             tc990_WAITING_FOR_HOST_REQUEST ) break;
        udelay(50); 
    }
    if ( count >= tc990_WAIT_COUNTER ){
        DBGPRINT_ERROR(("reset_adapter OUT: failed due to timeout waiting for adapter\n"));
        return 1;
    }
	DBGPRINT_FUNCTION(("reset_adapter OUT: success\n"));
    return 0;

}

/*----------------------------------------------------------------------
 * download_boot_record --
 *  This routine checks to see if the adapter is waiting for boot and then
 *	downloads the physical pointers to it
 *
 * Arguments:
 *  dev     - a pointer to the device to download to
 *	process - What firware responce to look for and test against
 *
 * Results:
 *  zero       if successful
 *	non-zero   If failure
 *----------------------------------------------------------------------
 */

static u16 download_boot_record(struct net_device *dev, u16 process)
{
    struct tc990_private *np = (struct tc990_private *)dev->priv;
    u32  val, counter;
    long ioaddr = dev->base_addr;
	DBGPRINT_INITIALIZE(("download_boot_record IN:\n"));

    /* Check if the adapter status is waiting for boot. */
    for ( counter = 0; counter < tc990_WAIT_COUNTER; counter++ ) {
        val = tc990_readl(ioaddr + tc990_3XP2HOST_COMM_0_REG); 
        if ( val == process ) break;
        udelay(50);      
    }

    if ( tc990_WAIT_COUNTER == counter  ){
	      DBGPRINT_ERROR(("download_boot_record OUT: adapter not waiting for boot\n"));
		    return 21;
    }
    /* register the ring with the firmware */
    tc990_writel(0, ioaddr +  tc990_HostTo3XP_COMM_2_REG);
    tc990_writel( np->ringPhysical, 
           ioaddr + tc990_HostTo3XP_COMM_1_REG );

    tc990_writel(tc990_BOOTCMD_REG_BOOT_RECORD, 
           ioaddr + tc990_HostTo3XP_COMM_0_REG);
        
    /* wait for the firmware to pick up the command. */
    for ( counter = 0; counter < tc990_WAIT_COUNTER; counter++ ) {
        val = tc990_readl(ioaddr + tc990_3XP2HOST_COMM_0_REG);
        if ( val != process )
            break;
        udelay(50);
    }
    
    if ( tc990_WAIT_COUNTER == counter ){
	      DBGPRINT_ERROR(("download_boot_record OUT: adapter still waiting for boot\n"));
		    return 22;
    }

    /* clear the tx and cmd ring write registers */
    tc990_writel(tc990_NULL_CMD, ioaddr + tc990_HostTo3XP_COMM_1_REG);
    tc990_writel(tc990_NULL_CMD, ioaddr + tc990_HostTo3XP_COMM_2_REG);
    tc990_writel(tc990_NULL_CMD, ioaddr + tc990_HostTo3XP_COMM_3_REG);
    tc990_writel(tc990_NULL_CMD, ioaddr + tc990_HostTo3XP_COMM_0_REG);
    
	DBGPRINT_INITIALIZE(("download_boot_record OUT: successful\n"));
    return 0;
}

/*----------------------------------------------------------------------
 * init_ring_zone --
 *  This routine is called to set up the rings used to communicate between
 *	the driver and teh firmware.  It also allocated the recieve buffers
 *
 * Arguments:
 *  dev     - a pointer to the device to initialize
 *
 * Results:
 *  non-zero  if failure
 *	0			   	If successful
 *----------------------------------------------------------------------
 */
static u16 init_ring_zone( struct net_device *dev )
{
    struct tc990_private *np = (struct tc990_private *)dev->priv;
    u32 physicalLow = (u32)np->shared_dma_addr;
    u16 index;
    RX_FREE_DSC *rxFreeDescriptor; 
    u16 rxBufferSize =  ETHERNET_MAXIMUM_FRAME_SIZE + 4; 
    struct sk_buff *skb;
		unsigned long addr;
	  DBGPRINT_INITIALIZE(("init_ring_zone IN:\n"));

    np->ringPhysical = physicalLow;

    /* initialize the BootRecord and HostRingReadWrite registers */

    np->shared->init.hostZeroWordUL     = physicalLow + sizeof(HOST_INIT_S); 
    np->shared->init.hostZeroWordHiUL     = 0;

    physicalLow                     += sizeof(HOST_INIT_S) + sizeof(u32); 
    np->shared->init.hostVarsPS     = physicalLow;
    np->shared->init.hostVarsHiUL     = 0;

    physicalLow                         += sizeof(HOST_VAR_S);
    np->ring_info.TxLoRing.RingBase        = (void*)bus_to_virt(physicalLow); 
    np->shared->init.hostTxLoStartUL     =  physicalLow;
    np->shared->init.hostTxLoStartHiUL    = 0;
    np->shared->init.hostTxLoSizeUL        = TX_ENTRIES * sizeof(TX_DESC);

    physicalLow += np->shared->init.hostTxLoSizeUL;
    np->ring_info.TxHiRing.RingBase = (void*)bus_to_virt(physicalLow); 
    np->shared->init.hostTxHiStartUL =  physicalLow;
    np->shared->init.hostTxHiStartHiUL = 0;
    np->shared->init.hostTxHiSizeUL = TX_ENTRIES * sizeof(TX_DESC);

    physicalLow += np->shared->init.hostTxHiSizeUL;
    /* 
     * Save the address of RxLo descriptor ring. 
     * This ring is filled by f/w.
     */
    np->ring_info.RxLoRing.RingBase = (void*)bus_to_virt(physicalLow); 
    np->shared->init.hostRxLoStartUL = physicalLow;
    np->shared->init.hostRxLoStartHiUL = 0;
    np->shared->init.hostRxLoSizeUL = RX_ENTRIES * sizeof(RX_DSC);

    physicalLow += np->shared->init.hostRxLoSizeUL;
    /*
     * Save the address of RxHi descriptor ring. 
     * This ring is filled by f/w.
     */
    np->ring_info.RxHiRing.RingBase = (void*)bus_to_virt(physicalLow); 
    np->shared->init.hostRxHiStartUL = physicalLow;
    np->shared->init.hostRxHiStartHiUL = 0;
    np->shared->init.hostRxHiSizeUL = RX_ENTRIES * sizeof(RX_DSC);

    physicalLow += np->shared->init.hostRxHiSizeUL;
    /* 
     * Save the address of Rx buffer ring. 
     * This ring is filled by driver.
     */
    np->ring_info.RxBuffRing.RingBase         = (void*)bus_to_virt(physicalLow); 
    np->shared->init.hostRxFreeStartUL         = physicalLow;
    np->shared->init.hostRxFreeStartHiUL     = 0;
    np->shared->init.hostRxFreeSizeUL        = RX_ENTRIES * sizeof(RX_FREE_DSC);

    physicalLow += np->shared->init.hostRxFreeSizeUL;
    /*
     * Save the command and response buffers
     */
    np->ring_info.CmdRing.RingBase        = (void*)bus_to_virt(physicalLow); 
    np->shared->init.hostCtrlStartUL     = physicalLow;      
    np->shared->init.hostCtrlStartHiUL     = 0;
    np->shared->init.hostCtrlSizeUL     = CMD_ENTRIES * sizeof(CMD_DSC);

    physicalLow += np->shared->init.hostCtrlSizeUL;
    np->ring_info.RspRing.RingBase         = (void*)bus_to_virt(physicalLow); 
    np->shared->init.hostRespStartUL     = physicalLow;
    np->shared->init.hostRespStartHiUL     = 0;
    np->shared->init.hostRespSizeUL     = RESPONSE_ENTRIES *  
                                          sizeof(RESPONSE_DSC);

    np->shared->var.hvWriteS.regRxBuffWriteUL = (RX_ENTRIES - 1) * 
                                             sizeof(RX_FREE_DSC);

    /*
     * Initialize counters  (from ResetRingStructures) 
     */
     np->ring_info.RxLoRing.LastWriteUL       = 0;        
     np->ring_info.RxHiRing.LastWriteUL       = 0;        
     np->ring_info.RxBuffRing.LastWriteUL     = 0;
     np->ring_info.TxLoRing.LastWriteUL       = 0;        
     np->ring_info.TxHiRing.LastWriteUL       = 0;        
     np->ring_info.CmdRing.LastWriteUL        = 0;

     np->ring_info.TxLoRing.LastReadUL        = 0;        
     np->ring_info.TxHiRing.LastReadUL        = 0;        
     np->ring_info.TxLoRing.WriteRegister     = tc990_HostTo3XP_COMM_3_REG;   
     np->ring_info.TxHiRing.WriteRegister     = tc990_HostTo3XP_COMM_1_REG; 
     np->ring_info.TxLoRing.PacketPendingNo   = 0;
     np->ring_info.TxHiRing.PacketPendingNo   = 0;

     np->ring_info.TxLoRing.NoEntries = TX_ENTRIES;
     np->ring_info.TxHiRing.NoEntries = TX_ENTRIES;
     np->ring_info.CmdRing.NoEntries = CMD_ENTRIES;
     np->ring_info.RspRing.NoEntries = RESPONSE_ENTRIES;

     np->slot_memory_size = ((RX_ENTRIES-1)*(sizeof(struct SLOT)));

     np->slot = pci_alloc_consistent(
                    np->pdev,
                    np->slot_memory_size,
                    &np->slot_physical
                    );

     if (!np->slot){
          DBGPRINT_ERROR((KERN_INFO "init_ring_zone OUT: Failed to allocate Slot space\n"));
				  return 50;
     }
     memset( np->slot, 0, np->slot_memory_size);
     np->resources_reserved |= TC990_SLOT_MEMORY_ALLOCATED;

     /*
      * Alloc slots
      * Put the addresses of all the receive buffers in the receive buffer
      * descriptor ring.    
      */
     for ( index = 0 ; index < RX_ENTRIES - 1; index++ ) {
         if ((skb = dev_alloc_skb(rxBufferSize)) == NULL) {
            DBGPRINT_ERROR((KERN_INFO "init_ring_zone OUT: Allocate rx skb failed.\n"));
            DBGPRINT_ERROR((KERN_INFO "init_ring_zone OUT: Try reducing RX_ENRIES value and recompile\n"));
            return 52;
          }
         skb->dev = dev;

         /* Save the information in the slot. */
         np->slot[index].skb = skb;

         /* Add the pci unmap code */
	       addr = pci_map_single(np->pdev, skb->tail, rxBufferSize, PCI_DMA_FROMDEVICE);
	       np->slot[index].physical_addr_lo =  addr;
	       np->slot[index].physical_addr_hi =  upper_bits((void*)addr);// 0 on 32 bit computers

         np->slot[index].physical_addr_hi = 0;
         np->slot[index].buffer_length = rxBufferSize;
     }
        
    /* Indicate all the buffers are free.  */
    rxFreeDescriptor = (RX_FREE_DSC*)np->ring_info.RxBuffRing.RingBase; 
    for(index = 0; index < RX_ENTRIES - 1; index++ ) {
        
        rxFreeDescriptor->physical_addr_lo = np->slot[index].physical_addr_lo;
        rxFreeDescriptor->physical_addr_hi = np->slot[index].physical_addr_hi;
        rxFreeDescriptor->virtual_addr_lo = index;
        rxFreeDescriptor->virtual_addr_hi = 0;
        rxFreeDescriptor++;

     }
	  DBGPRINT_INITIALIZE(("init_ring_zone OUT: Successful\n"));
    return 0;
}

/*----------------------------------------------------------------------
 * download_runtime_image --
 *  This routine downloads the runtime version of the firmware to the NIC
 *  to allow the card to function in full up and running mode
 *
 * Arguments:
 *  dev     - a pointer to the device to download to
 *
 * Results:
 *  1		if failure
 *	0		If successful
 *----------------------------------------------------------------------
 */
static u16 download_runtime_image(struct net_device *dev)
{
    struct tc990_private *np = (struct tc990_private *)dev->priv;
    tc990_FILE_HEADER *fileHeader;
    u32 index;
    tc990_FILE_SECTION *fileSection;
    u32 count, value, oldIntMask, oldIntEnable;
    u32 tempLength, thisSectionHeaderLocation, thisSectionDataLocation;
    void *sectionDataBuffer; 
    u32 start_address, numBytesInThisSection, checksum;
    u32  sections;
    long ioaddr = dev->base_addr; 
	DBGPRINT_INITIALIZE(("download_runtime_image IN:\n"));

    np->DownloadPageVirtual = pci_alloc_consistent(np->pdev,tc990_IMAGE_SIZE,
                                                   &np->DownloadPagePhysical);
                        
    if (np->DownloadPageVirtual == NULL){
	      DBGPRINT_ERROR(("download_runtime_image OUT: failed to allocate page memory\n"));
		    return 1;
    }
    fileHeader = (tc990_FILE_HEADER*)tc990image; 

    if((fileHeader->tagID[0] != 'T') || (fileHeader->tagID[1] != 'Y') ||
       (fileHeader->tagID[2] != 'P') || (fileHeader->tagID[3] != 'H') ||
       (fileHeader->tagID[4] != 'O') || (fileHeader->tagID[5] != 'O') ||
       (fileHeader->tagID[6] != 'N')) { 

        pci_free_consistent(np->pdev, tc990_IMAGE_SIZE, 
                            np->DownloadPageVirtual, np->DownloadPagePhysical);
	      DBGPRINT_ERROR(("download_runtime_image OUT: Runtime image not valid\n"));
        return 1;
    }

    if (reset_adapter(dev)) {

        pci_free_consistent(np->pdev, tc990_IMAGE_SIZE, 
                            np->DownloadPageVirtual, 
                            np->DownloadPagePhysical
                            );
	      DBGPRINT_ERROR(("download_runtime_image OUT: Unable to restet adapter\n"));
        return 1;
    }

    udelay(5000);    
    oldIntEnable = tc990_readl(ioaddr + tc990_3XP2HOST_COMM_0_REG); 

    /* Mask the interrupts and enable the interrupts. */
    oldIntEnable = tc990_readl(ioaddr + tc990_INT_ENABLE_REG); 
    tc990_writel(oldIntEnable | tc990_3XP_COMM_INT0, ioaddr + tc990_INT_ENABLE_REG);
    oldIntMask = tc990_readl(ioaddr + tc990_INT_MASK_REG);
    tc990_writel(oldIntMask | tc990_3XP_COMM_INT0, ioaddr + tc990_INT_MASK_REG );

    for ( count = 0; count < tc990_WAIT_COUNTER ; count++ ) {
        value   = tc990_readl(ioaddr + tc990_3XP2HOST_COMM_0_REG);
        if ( value == tc990_WAITING_FOR_HOST_REQUEST ) break;
        udelay(50);    
    }

    if ( count == tc990_WAIT_COUNTER ) {
        pci_free_consistent(np->pdev, tc990_IMAGE_SIZE,
                            np->DownloadPageVirtual, 
                            np->DownloadPagePhysical);
	      DBGPRINT_ERROR(("download_runtime_image OUT: timeout error masking interupts\n"));
        return 1;
    }

    udelay(5000);    

    /* Acknowledge the status. */

    tc990_writel(tc990_3XP_COMM_INT0, ioaddr + tc990_INT_STATUS_REG);
    tc990_writel(fileHeader->ExecuteAddress, ioaddr + tc990_HostTo3XP_COMM_1_REG);
    tc990_writel(tc990_BOOTCMD_RUNTIME_IMAGE, ioaddr + tc990_HostTo3XP_COMM_0_REG); 

    thisSectionHeaderLocation = sizeof(struct _tc990_FILE_HEADER ); 

    sections = fileHeader->NumSections;   

    for (index = 0; index < sections; index++) {   

        fileSection = (tc990_FILE_SECTION*)
              (tc990image +  thisSectionHeaderLocation );

        numBytesInThisSection      = fileSection->num_bytes;
        start_address              = fileSection->start_address;
        thisSectionDataLocation    = sizeof( tc990_FILE_SECTION );

        while(numBytesInThisSection) {

            /* wait for 3cr990 to be ready to accept this section.  */

            for ( count = 0; count < tc990_WAIT_COUNTER; count++ ) {

                value = tc990_readl(ioaddr + tc990_INT_STATUS_REG );
                if ( value & tc990_3XP_COMM_INT0 ) break;
                udelay(50);

            }
            
            if ( count == tc990_WAIT_COUNTER ) {
                pci_free_consistent(np->pdev, tc990_IMAGE_SIZE, 
                                    np->DownloadPageVirtual, 
                                    np->DownloadPagePhysical);
	      				DBGPRINT_ERROR(("download_runtime_image OUT: timout waiting for 3xp status\n"));
                return 1;
            }

            udelay(5000);    
            tc990_writel(tc990_3XP_COMM_INT0, ioaddr + tc990_INT_STATUS_REG);
            value = tc990_readl(ioaddr + tc990_3XP2HOST_COMM_0_REG);

            if ( value != tc990_WAITING_FOR_SEGMENT ){

                pci_free_consistent(np->pdev, tc990_IMAGE_SIZE, 
                    np->DownloadPageVirtual, np->DownloadPagePhysical);
	      				DBGPRINT_ERROR(("download_runtime_image OUT: error 3xp not ready for segment\n"));
                return 1;

            } 

            /* Calculate the location of the data. */
            sectionDataBuffer = (u8*)(tc990image +  
                                      thisSectionHeaderLocation +
                                      thisSectionDataLocation );
            /* 
             * 3cr990 is ready to accept section. 
             * Prepare the section. Download entire 
             * segment if it fits 
             */
            if (numBytesInThisSection > TC990_DOWNLOAD_BLOCK_SIZE)
                tempLength = TC990_DOWNLOAD_BLOCK_SIZE;
            else
                tempLength  = numBytesInThisSection;
            memcpy(np->DownloadPageVirtual, sectionDataBuffer, tempLength);
            checksum = calculate_buffer_checksum(
                           (u16 *)np->DownloadPageVirtual, tempLength);

            tc990_writel(tempLength, ioaddr + tc990_HostTo3XP_COMM_1_REG);
            tc990_writel(checksum, ioaddr + tc990_HostTo3XP_COMM_2_REG);
            tc990_writel(start_address, ioaddr + tc990_HostTo3XP_COMM_3_REG);
            tc990_writel(0, ioaddr + tc990_HostTo3XP_COMM_4_REG);
            tc990_writel(np->DownloadPagePhysical, 
                   ioaddr + tc990_HostTo3XP_COMM_5_REG);

            tc990_writel(tc990_BOOTCMD_SEGMENT_AVAILABLE, 
                   ioaddr + tc990_HostTo3XP_COMM_0_REG);

            /* Update length and load address for next pass.*/
            numBytesInThisSection    -= tempLength;
            start_address            += tempLength;
            
            /* Update the section data location. */
            thisSectionDataLocation += tempLength;

        }  

        /* Update the section header location */
        numBytesInThisSection     = fileSection->num_bytes;
        thisSectionHeaderLocation += (numBytesInThisSection +
                                      sizeof(tc990_FILE_SECTION));
    }

    udelay(5000);        
    /*
     * We have been able to download all the sections successfully.
     * Tell 3cr990 we are done and wait for a boot message.
     */
        
    tc990_writel(tc990_BOOTCMD_DOWNLOAD_COMPLETE, ioaddr+tc990_HostTo3XP_COMM_0_REG);
    for ( count = 0; count < tc990_WAIT_COUNTER; count++ ) {

        value = tc990_readl(ioaddr + tc990_3XP2HOST_COMM_0_REG);
        if ( value == tc990_WAITING_FOR_BOOT ) break;
        udelay(50);

    }

    if ( count == tc990_WAIT_COUNTER ) {
        pci_free_consistent(np->pdev, tc990_IMAGE_SIZE, 
                            np->DownloadPageVirtual, np->DownloadPagePhysical);
	      DBGPRINT_ERROR(("download_runtime_image OUT: error 3xp not waiting for boot\n"));
        return 1;
    }

    udelay(100); 

    /* Program the original values back on IntEnable and IntMask */
    tc990_writel(oldIntMask, ioaddr + tc990_INT_MASK_REG);
    tc990_writel(oldIntEnable, ioaddr + tc990_INT_ENABLE_REG);
    
    pci_free_consistent(np->pdev, tc990_IMAGE_SIZE, np->DownloadPageVirtual,
                        np->DownloadPagePhysical);
	DBGPRINT_INITIALIZE(("download_runtime_image OUT: successful\n"));
    return 0;
}

/*----------------------------------------------------------------------
 * calculate_buffer_checksum --
 *  This routine cal;culates the checksum for a buffer to pass it down
 *	to the Firmware
 *
 * Arguments:
 *  Buffer     - buffer to checksum
 *  Count     - size of buffer
 *
 * Results:
 *  1		if failure
 *	0		If successful
 *----------------------------------------------------------------------
 */
static u16 calculate_buffer_checksum(u16 *Buffer,  u32 Count)
{
    u32   checksum = 0;
		//DBGPRINT_INITIALIZE(("calculate_buffer_checksum IN\n"));
    while ( Count > 1 ){
        /* This is the inner loop. */
        checksum    += *Buffer++; 
        Count       -= 2;
        /* Fold 32-bit checksum to 16 bits. */
        while ( checksum >> 16 )
            checksum = ( checksum & 0xffff ) + ( checksum >> 16 );
    }    
    if ( Count > 0 ) 
        checksum += *Buffer;
    while ( checksum >> 16 )
        checksum = ( checksum & 0xffff ) + ( checksum >> 16 );
		//DBGPRINT_INITIALIZE(("calculate_buffer_checksum OUT: successful\n"));
     return (u16)(~checksum );
}

/*----------------------------------------------------------------------
 * update_tx_ring_index --
 *  This routine updates the tx ring index
 *
 * Arguments:
 *  writePUW     - pointer to the current index to the tx ring
 *
 * Results:
 *  none
 *----------------------------------------------------------------------
 */
static void update_tx_ring_index (u32 *writePUW)
{
		DBGPRINT_SEND(("update_tx_ring_index IN\n"));
    *writePUW += sizeof(TX_DESC);
      if (*writePUW >= (TX_ENTRIES * sizeof(TX_DESC)))
        *writePUW = 0;
		DBGPRINT_SEND(("update_tx_ring_index OUT: successful\n"));
}

/*----------------------------------------------------------------------
 * SetMacAddress -- 
 *  This routine first checks to see if the device is running.  If it is not running
 *  then it changes the StationAddress in memory to the passed in address.  When this
 *  Device is reopened this Address will be written down to the card
 *
 *
 * Arguments:
 *      Device - Pointer to the device structure of the Device to Alter
 *	SockPtr - A viod pointer that points to the desired MacAddress
 *
 * Results:
 *      ENODEV if the device is busy 
 *----------------------------------------------------------------------
 */
int SetMacAddress(struct net_device *Device, void *SockPtr)
{
struct sockaddr *addrp = SockPtr;
struct tc990_private *np = (struct tc990_private *)Device->priv;
int index;

    DBGPRINT_FUNCTION(("SetMacAddress IN\n"));

	if (netif_running(Device)){
		DBGPRINT_ERROR(("SetMacAddress OUT: Failure, attempted while interface open\n"));
		return ENODEV;
	}

	for (index=0; index < 6; index++){
        np->StationAddress[index] = addrp->sa_data[index];
		Device->dev_addr[index] = addrp->sa_data[index];
	}
	DBGPRINT_FUNCTION(("SetMacAddress OUT: Success\n"));
	return 0;
	
} 

/*----------------------------------------------------------------------
 * ReadPermanentAddress -- 
 *  This routine reads the PermanentMacAddress from the NIC and Stores 
 *  it in the device structure
 *
 *
 * Arguments:
 *      Device - Pointer to the device structure of the Device to Read
 *
 * Results:
 *      NIC_STATUS_SUCCESS if successful
 *      NIC_STATUS_FAILURE if no NICs found
 *----------------------------------------------------------------------
 */
u32 ReadPermanentAddress(struct net_device *dev){
    u16 retval;
    u32 stationAddressLo = 0;
    u16 stationAddressHi = 0;
    DBGPRINT_INITIALIZE(("ReadPermanentAddress IN\n"));

    retval = issue_command(dev, tc990_CMD_STATION_ADR_READ,
             0, 0, 0, &stationAddressHi, &stationAddressLo, NULL, 1);

    if (retval) { 
    	DBGPRINT_ERROR(("ReadPermanentAddress out Faiure\n"));
        return NIC_STATUS_FAILURE; 

    }

    dev->dev_addr[0] = ((u8*)(&stationAddressHi))[1];
    dev->dev_addr[1] = ((u8*)(&stationAddressHi))[0];
    dev->dev_addr[2] = ((u8*)(&stationAddressLo))[3];
    dev->dev_addr[3] = ((u8*)(&stationAddressLo))[2];
    dev->dev_addr[4] = ((u8*)(&stationAddressLo))[1];
    dev->dev_addr[5] = ((u8*)(&stationAddressLo))[0];

    DBGPRINT_INITIALIZE(("ReadPermanentAddress Out Success\n"));
    return NIC_STATUS_SUCCESS;
}

/*----------------------------------------------------------------------
 * WriteMacAddressToNic -- 
 *  This routine first checks to see if the StationAddress has been Altered.
 *  If it has been altered by a previous call to SetMacAddress 
 *  then it writes this address down to the Hardware
 *
 * Arguments:
 *      dev - Pointer to the device structure of the NIC to Alter
 *
 * Results:
 *      NIC_STATUS_SUCCESS if successful
 *      NIC_STATUS_FAILURE if no NICs found
 *----------------------------------------------------------------------
 */
u32 WriteMacAddressToNic(struct net_device *dev){

	struct tc990_private *np = (struct tc990_private *)dev->priv;
    u32 stationAddressLo = 0;
    u16 stationAddressHi = 0;
	u32 index, retval, value = 0;

    DBGPRINT_FUNCTION(("WriteMacAddressToNic IN\n"));
	for (index=0; index < 6; index++){
			value |= np->StationAddress[index];
	}
	//
	// If the station address has not been overriden, do nothing
	//
	if (!value) {
    DBGPRINT_FUNCTION(("WriteMacAddressToNic OUT No Change\n"));
    return NIC_STATUS_SUCCESS;
	}
	for (index=0; index < 6; index++){
			dev->dev_addr[index] = np->StationAddress[index];
	}

	((u8*)(&stationAddressHi))[1] = dev->dev_addr[0];
	((u8*)(&stationAddressHi))[0] = dev->dev_addr[1];
	((u8*)(&stationAddressLo))[3] = dev->dev_addr[2];
	((u8*)(&stationAddressLo))[2] = dev->dev_addr[3];
	((u8*)(&stationAddressLo))[1] = dev->dev_addr[4];
	((u8*)(&stationAddressLo))[0] = dev->dev_addr[5];
	
    retval = issue_command(dev, tc990_CMD_STATION_ADR_WRITE,
             stationAddressHi, stationAddressLo, 0, NULL, NULL, NULL, 1);

    if (retval) { 
    	DBGPRINT_ERROR(("WriteMacAddressToNic OUT Failed Change\n"));
    	return NIC_STATUS_FAILURE; 
    }
    DBGPRINT_FUNCTION(("WriteMacAddressToNic OUT Changed\n"));
    return NIC_STATUS_SUCCESS;
}

/*----------------------------------------------------------------------
 * IoctlHandler --
 *  This routine is called by Linux when our device recieves an Ioctl.
 *	It parses the command and calls the appropriot functionality if we
 *	support that command
 *
 * Arguments:
 *  dev     - Pointer to the device structure of the NIC
 *	ifr     - pointer to the data for the request
 *	command - int that holds the number of the command for the switch statment
 *
 * Results:
 *  EPERM       if the command is unsuccessful
 *  EOPNOTSUPP  if the command is not supported
 *	0			If successful
 *----------------------------------------------------------------------
 */
int IoctlHandler( struct net_device *dev, struct ifreq *ifr, int command ){
        int retval;
        long ioaddr;
        u16 *data, reply;
        struct tc990_private *np;

        DBGPRINT_IOCTL(("IoctlHandler: IN\n"));

        np = (struct tc990_private *)dev->priv;
        ioaddr = dev->base_addr;
        data = (u16 *)&ifr->ifr_data;


        switch(command) {

        case SIOCDEVPRIVATE:            /* Get the address of the PHY in use. */
			DBGPRINT_IOCTL(("IoctlHandler: SIOCDEVPRIVATE\n"));
			data[0] = 0;// No Phy Address to give
			/* Fall Through */

        case SIOCDEVPRIVATE+1:          /* Read the specified MII register. */
	  		/* per B, change data[0] to date[1] */
			DBGPRINT_IOCTL(("IoctlHandler: SIOCDEVPRIVATE + 1\n"));
			retval = issue_command(dev, tc990_CMD_PHYSICAL_MNGT_READ,
					0, data[1], 0, &(reply), NULL, NULL, 1);
			if (retval) { 
				DBGPRINT_ERROR(("IoctlHandler OUT Faiure to read MII\n"));
				return -EPERM; 
			}
			data[3] = reply;
			DBGPRINT_IOCTL(("IoctlHandler: MII read %x results %x\n", data[1], reply));
			return 0;


        case SIOCDEVPRIVATE+2:          /* Write the specified MII register. */
			DBGPRINT_IOCTL(("IoctlHandler: SIOCDEVPRIVATE + 2 not supported\n"));
			return 0;

#ifdef NICE_SUPPORT
        case SIOCNICE:
			{
				struct nice_req* nrq;
				nrq = (struct nice_req*)&ifr->ifr_ifru;
				if( nrq->cmd == NICE_CMD_QUERY_SUPPORT ) {
						nrq->nrq_magic = NICE_DEVICE_MAGIC;
						nrq->nrq_support_rx = 1;
						return 0;
				}
				else if( nrq->cmd == NICE_CMD_SET_RX ) {
						np->nice_rx = nrq->nrq_rx;
						np->nice_ctx = nrq->nrq_ctx;
						return 0;
				}
				else if( nrq->cmd == NICE_CMD_GET_RX ) {
						nrq->nrq_rx = np->nice_rx;
						nrq->nrq_ctx = np->nice_ctx;
						return 0;
				}
				else {
						return -EOPNOTSUPP;
				}
				break;
			}
#endif /* NICE_SUPPORT */

        default:
			    DBGPRINT_IOCTL(("IoctlHandler: unsupported IOCTL\n"));
                return -EOPNOTSUPP;
        }
}


/*
 * Local variables:
 *  UP-compile-command: "gcc -DMODULE -D__KERNEL__ -Wall -Wstrict-prototypes -I/usr/src/linux/include -O6 -c 3c990.c `[ -f /usr/include/linux/modversions.h ] && echo -DMODVERSIONS`"
 *  SMP-compile-command: "gcc -D__SMP__ -DMODULE -D__KERNEL__ -Wall -Wstrict-prototypes -I/usr/src/linux/include -O6 -c 3c990.c `[ -f /usr/include/linux/modversions.h ] && echo -DMODVERSIONS`"
 *  c-indent-level: 4
 *  c-basic-offset: 4
 *  tab-width: 4
 * End:
 */




