/* 
 * linux/fs/supermount/init.c
 *
 *  (C) Copyright 2001-2002 Juan Quintela <quintela@mandrakesoft.com>
 *      Released unde GPL v2.
 *
 */

#include <linux/module.h>
#include <linux/init.h>
#include <linux/fs.h>

#include "supermount_i.h"

static DECLARE_FSTYPE(supermount_fs_type, "supermount",
		      supermount_read_super, 0);

static int __init
init_supermount_fs(void)
{
	return register_filesystem(&supermount_fs_type);
}

static void __exit
exit_supermount_fs(void)
{
	unregister_filesystem(&supermount_fs_type);
}

EXPORT_NO_SYMBOLS;

MODULE_AUTHOR("Stephen Tweedie, Alexis Mikhailov, Juan Quintela and others");
MODULE_DESCRIPTION("Supermount");
MODULE_LICENSE("GPL");
module_init(init_supermount_fs);
module_exit(exit_supermount_fs);
