
/* Begin Status/Return value declarations */

#define GR_ALLOW 1
#define GR_NOTFOUND -1
#define GR_DENY 0

#define GR_LOADING 0x01
#define GR_DISABLED 0x02
#define GR_READY 0x04
#define GR_1ST 0x08
/* Debugging mode*/ 
#define GR_TESTING 0x080

#ifdef CONFIG_GR_DEF_DENY
#define GR_DEFAULT GR_DENY
#endif
#ifdef CONFIG_GR_DEF_DENY_ROOT
#define GR_DEFAULT !(current->euid) ? GR_DENY : GR_ALLOW;
#endif
#ifdef CONFIG_GR_DEF_ALLOW
#define GR_DEFAULT GR_ALLOW
#endif

/* End Status declarations */




/* Begin  ACL declarations */
#define GR_READ 0x01
#define GR_APPEND 0x02
#define GR_WRITE 0x04
#define GR_EXEC 0x08
#define GR_HIDDEN 0x10
#define GR_OVERRIDE 0x20 /* Override File ACL, useful for proc only*/
#define GR_PROTECTED 0x40
#define GR_NONEXISTANT 0x40000000 /* File does not exist, check parent. Done when *checking* for a file's ACL */


/* Standard stuff done, on to File ACL stuff */

#define GR_FILE_READ GR_READ
#define GR_FILE_APPEND GR_APPEND
#define GR_FILE_WRITE (GR_WRITE | GR_APPEND)
#define GR_FILE_EXEC GR_EXEC
#define GR_FILE_HIDDEN GR_HIDDEN


#define GR_PROC_READ GR_READ
#define GR_PROC_APPEND GR_APPEND
#define GR_PROC_WRITE (GR_WRITE|GR_APPEND); /* write access implies append access*/
#define GR_PROC_EXEC GR_EXEC
#define GR_PROC_ACCESS GR_HIDDEN
#define GR_PROC_OVERRIDE GR_OVERRIDE
#define GR_PROC_HIDDEN GR_HIDDEN /* Hidden, unkillable(except by init) process. Good for hiding your IDSes / logging daemons:)*/
#define GR_PROC_PROTECTED GR_PROTECTED
 
/* Begin TODO */
#define GR_REQSUM 0x200 /* Require program to have SHAsum in database*/
#define GR_INHERIT 0x400 /* Children inherit parent's process acls*/
#define GR_AUTH 0x100    /* Require secondary authentication before execution*/
#define GR_AUTH_IF_ROOT 0x800 /* Require secondary authentication IF the user has root priveleges */

#define GR_FILE_REQSUM GR_REQSUM
#define GR_FILE_AUTH GR_AUTH
#define GR_PROC_REQSUM GR_REQSUM
#define GR_PROC_INHERIT GR_INHERIT
#define GR_PROC_AUTH GR_AUTH
#define GR_PROC_AUTH_IF_ROOT GR_AUTH_IF_ROOT
/* End TODO */

#define GR_PROC_EXTRA (GR_PROC_OVERRIDE|GR_PROC_REQSUM|GR_PROC_INHERIT|GR_PROC_AUTH)
/* Extra things that must be checked after a search*/

#define GR_FILE_EXTRA (GR_FILE_REQSUM|GR_FILE_AUTH)
#define GR_RW (GR_READ|GR_WRITE)
#define GR_RX (GR_READ|GR_EXEC)
#define GR_RWX (GR_READ|GR_WRITE|GR_EXEC)

/* End ACL Declarations */

